
import Qt3D.Core 2.0
import Qt3D.Render 2.15
import Qt3D.Input 2.0
import Qt3D.Extras 2.9
import Qt3D.Logic 2.15

import QtQuick 2.10 as QQ2


Entity {
    id: sceneRoot

    BasicCamera {
        id: camera
        position: Qt.vector3d( -1.0, 2.0, 2.6 )
        upVector: Qt.vector3d( 0.0, 1.0, 0.0 )
        viewCenter: Qt.vector3d( 0.0, 0.0, 0.0 )
    }

    function setBasicCameraValues(pos, up, centre) {
        camera.position = pos
        camera.upVector =  up
        camera.viewCenter = centre
    }

    function pinchZoom(scale)
    {
        sOrbitCamController.mousehandler.zoom(scale)
    }

   //FirstPersonCameraController { camera: camera }

//    OrbitCameraController {
//        camera: camera
//        linearSpeed: 10
//        lookSpeed: 240
//    }

    SOrbitCameraController{
       id: sOrbitCamController
       camera: camera
       linearSpeed: 10
       lookSpeed: 400
    }

    components: [
        RenderSettings {
            activeFrameGraph: ForwardRenderer {
                camera: camera
                frustumCulling: false
                clearColor: "transparent"
                //clearColor: "#2d2d2d"
            }
        },
        InputSettings { }
    ]

    ArrowModel {
        id: arrowModel

        xScale: 10.0
        yScale: 10.0
        zScale: 10.0

        enableEntity: true
        visibleEntity: true
        flipEntity: true
    }
}
