import Qt3D.Core 2.0
import Qt3D.Render 2.15
import Qt3D.Input 2.0
import Qt3D.Extras 2.15

import QtQuick 2.12 as QQ2

Entity {
    id: rootArrow

    property real xAxisRotation: 0.0
    property real yAxisRotation: 0.0
    property real zAxisRotation: 0.0
    property real xAxisTranslation: 0.0
    property real yAxisTranslation: 0.0
    property real zAxisTranslation: 0.0
    property real xScale: 1.0
    property real yScale: 1.0
    property real zScale: 1.0
    property matrix4x4 transformMatrix: Qt.matrix4x4()
    property bool enableEntity: false
    property bool visibleEntity: false
    property bool flipEntity: false

    enabled: enableEntity

    MetalRoughMaterial {
        id: arrowMaterial
        baseColor: Qt.rgba( 0.0588, 0.247, 0.392, 1.0 )
        metalness: 0.3
        roughness: 0.4
    }

    Transform {
        id: arrow_transform
        matrix: {

            var m = Qt.matrix4x4();

            //transformMatrix.translate(Qt.vector3d(2.5, 2.0, 0.0));

            m.scale(rootArrow.xScale, rootArrow.yScale, rootArrow.zScale);

            m.translate(Qt.vector3d(rootArrow.xAxisTranslation*(2.0/200.0),
                                    rootArrow.yAxisTranslation*(2.0/200.0),
                                    rootArrow.zAxisTranslation*(2.0/200.0)));

            m.rotate(rootArrow.xAxisRotation, Qt.vector3d(1, 0, 0));
            m.rotate(rootArrow.yAxisRotation, Qt.vector3d(0, 1, 0));
            m.rotate(rootArrow.zAxisRotation, Qt.vector3d(0, 0, 1));

            if(flipEntity)
                m.rotate(180, Qt.vector3d(1, 0, 0));

            m.translate(Qt.vector3d(0.0, 0.055, 0.0));

            return m;
        }
    }

    QQ2.ParallelAnimation {
        loops: QQ2.Animation.Infinite
        running: visibleEntity
        QQ2.NumberAnimation {
            target: rootArrow //arrow_transform
            property: "enableEntity"
            duration: 300 //1100
            from: 0
            to: 1

            //loops: QQ2.Animation.Infinite
            //running: visibleEntity
        }
    }


    Mesh {
        id: arrowMesh
        source: "qrc:/obj/ArrowMesh.obj"
    }

    components: [ arrowMesh, arrowMaterial, arrow_transform ]
}
