
import QtQuick 2.0
import QtQuick.Scene3D 2.10
import Qt3D.Core 2.10
import Qt3D.Render 2.15
import Qt3D.Input 2.0
import Qt3D.Extras 2.15

import QtQuick.Controls 1.0
import QtQuick.Layouts 1.0


Item {

    id: root

    Rectangle {
        id: scene
        anchors.fill: parent
        //anchors.top: parent.top
        //anchors.bottomMargin: 75
        color: "gray"
        opacity:0.9

        PinchArea {
            anchors.fill: scene
            pinch.target: scene3d
            property real pinchSensitivity: 1.0
            onPinchUpdated: {

                animate.pinchZoom((pinch.scale - (pinch.previousScale+(0.00001))) * pinchSensitivity)
            }

            onPinchStarted:{
                //console.log("onPinchStarted")
            }

            MouseArea {
                id: pan_mouse_area
                anchors.fill: parent
                //hoverEnabled: true

                onPressed: {
                   //console.log("onPressed")
                }

            }

        }

		Scene3D {
			id: scene3d
			anchors.fill: parent
			focus: true
			aspects: ["input", "logic"]
			cameraAspectRatioMode: Scene3D.AutomaticAspectRatio

			AnimatedEntity {
				id: animate
			}
		}
    }
}
